# Library

https://library-5lbx6lbgwq-lz.a.run.app/

## Description

Library is a web page that allows the user to browse a books library with possibility to mark favorite books.
It contains two views:

- all
- favorites

### All Books View

The user can browser all books. There is a maximal number of books per page. The page number might be changed using the pagination control located at the bottom.

List of books is fetched from existing API `https://example-data.draftbit.com/books?_page=${currentPage}&_limit=${booksPerPage}`.

### Favorites Books View

List of favorite books is created by the user. A book can be added to favorite list by using the clickable heart icon near the book's cover.
The favorites books are stored in the user's browser local storage.

## Book Modal

When the user clicks on one of the book cards, more information about the book is displayed. The Book Modal contains data such as:

1. title
2. authors
3. a brief description of the book
4. rating
5. all list of genres
6. cover photo
7. quotes

## Search Form

It is located on top of the page. It allows to search books by text. A book is matched during searching when the search text is contained by:

- title
- authors
- description
- genre list

The searching is done differently depending on the view. In the All Books View, there is used API call `https://example-data.draftbit.com/books?q=${searchedBook}` to get matched books. In the Favorite Books View, the favorite books list from local storage is searched.

## URL Navigation

One of the purpose of this project was to practice a use of URL parameters. The possible URL addresses that can be used in this project:

- https://library-5lbx6lbgwq-lz.a.run.app/
- https://library-5lbx6lbgwq-lz.a.run.app/per_page/*:numberOfBookPerPage*/page/*:pageNumber*
- https://library-5lbx6lbgwq-lz.a.run.app/search/*:search*
- https://library-5lbx6lbgwq-lz.a.run.app/id/*:id*
- https://library-5lbx6lbgwq-lz.a.run.app/favBooks
- https://library-5lbx6lbgwq-lz.a.run.app/favBooks/per_page/*:numberOfBookPerPage*/page/*:pageNumber*
- https://library-5lbx6lbgwq-lz.a.run.app/favBooks/search/*:search*
- https://library-5lbx6lbgwq-lz.a.run.app/favId/*:id*

## Deployment

1. Create _Dockerfile_ to describe docker image that contains ReactJs application. Keep in mind that the application should use the port number read from `PORT` environment variable.
2. Create docker image with the given tag

```bash
$ docker build -t library:1.0 .

# You can try starting image using docker compose file with following comment
$ docker-compose -f docker-compose-frontend.yml up
$ docker-compose -f docker-compose-frontend.yml down
```

3. Install gcloud CLI *https://cloud.google.com/sdk/docs/install*
4. Log in to the gcloud by running the following command

```bash
$ gcloud auth login
```

5. Configure Docker to access Google Cloud Container Registry

```bash
gcloud auth configure-docker
```

6. Create new project in Google Cloud project name: library and turn it on
7. Tag the docker image

```bash
# Tag: <Container Registry Domain>/<Project ID>/<Image Name>
$ docker tag library:1.0 gcr.io/soy-ascent-383019/library:1.0
```

8. Upload the image to Google Cloud

```bash
$ docker push gcr.io/soy-ascent-383019/library:1.0
```

9. Go to Google Cloud Run and create new service with the previously uploaded docker image
10. Use the URL generated by Google Cloud Run to open your page
    https://library-5lbx6lbgwq-lz.a.run.app/
